#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <sys/fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <linux/vt.h>
#include <string.h>
#include <ggi/graphlib.h>

ggi_color pal[256];

int randnum(int max)
{ return (rand()%max); }

static inline int slow_drawbox(int x,int y,int w,int h)
{ while(h--) ggi_drawhline(x,y++,w); return 0; }

int main(void)
{ int t,x,c,y;
  int sx[]={1600,1280,1280,1024,1024,800,640,640,640,640,640,320,320,320,160};
  int sy[]={1200,1280, 960,1024, 768,600,480,400,200,100, 50,240,200,100,120};

  ggi_init();
         
  for(t=0;t<sizeof(sx)/sizeof(int);t++)
  {
   if (ggi_graphmode(sx[t],sy[t],sx[t],sy[t],GT_8BIT)) continue;
   printf("Mode OK:%dx%d\n",sx[t],sy[t]);

   ggi_setcolor(0);
   ggi_fillscreen();

   for(c=0;c<256;c++)
    { pal[c].r=c*4;pal[c].g=4*(255-c);pal[c].b=(128-abs(128-c))*7; }
   ggi_setpalvec(0,256,pal);
   
   for(y=0;y<5;y++)
   { for(x=0;x<500;x++)
     { ggi_setcolor(randnum(256));
       ggi_drawbox(randnum(sx[t]/4),randnum(sy[t]/2),
      		   randnum(sx[t]/4),randnum(sy[t]/2));
     }

     for(x=0;x<500;x++)
     { ggi_setcolor(randnum(256));
       slow_drawbox(randnum(sx[t]/4)+sx[t]/2,randnum(sy[t]/2),
     		    randnum(sx[t]/4)        ,randnum(sy[t]/2));
     }
   }
   ggi_getch();
  }
  ggi_exit();
  return(0);
}
